#ifndef INTERFACE_SDEVENT
#define INTERFACE_SDEVENT  1

typedef enum _sd_event_e  
{
 sd_key_down =1 
 ,sd_key_up 
 ,sd_mouse_button_press 
 ,sd_mouse_button_release 
 ,sd_scrollwheel 

 ,sd_cursor_move 
 ,sd_cursor_enter 
 ,sd_cursor_exit 
 
 ,sd_system_event 
 ,sd_sd_event 
 ,sd_application_event 
 ,sd_user_event 
 
} sd_event_t ;

enum sd_mouse_flag_e
{
 sd_flag_mouse_button_1_press = (1<<0) 
 ,sd_flag_mouse_button_2_press = (1<<1) 
 ,sd_flag_mouse_button_3_press = (1<<2) 
 ,sd_flag_mouse_wheel_press    = (1<<5) 
 ,sd_flag_mouse_wheel_release  = (1<<6) 
 ,sd_flag_mouse_wheel_up       = (1<<7) 
 ,sd_flag_mouse_wheel_down     = (1<<8) 

};

enum sd_key_flag_e
{
 sd_flag_shift_key       =  (1<<0)
 ,sd_flag_control_key     =  (1<<1)
 ,sd_flag_alt_key         =  (1<<2)
 ,sd_flag_function_key    =  (1<<3)
 ,sd_flag_pad_key         =  (1<<4)
};
@class SDWindow ;

extern Class SDEvent_fast;
@interface SDEvent : SDObject
{
@public
 sd_event_t type ;
 ulong event_data;
 ulong pos_x , pos_y ;
 ulong flag ;
 ulong time_sec;
 ulong time_msec ;
 void * adding_event_data ; 
}


-(id)type: (sd_event_t) _type 
     data: (ulong) _event_data 
        x: (ulong) _x 
        y: (ulong) _y 
     flag: (ulong) _flag 
      sec: (ulong) _sec
     msec: (ulong) _msec
   adding: (void *) _adding_data ;

-(id)type:(sd_event_t) _type ;
-(sd_event_t)type ;

-(id)eventData: (ulong) _event_data ;
-(ulong) eventData ;

-(id)flag: (ulong)_flag ;
-(ulong)flag ;

-(id)time: (ulong)_start with:(short)_m_start  ;
-(ulong)time ;
-(short)timeMsec;

-(id) eventData: (ulong) _event_data ;
-(ulong) eventData ;

-(id) addingEventData: (void *) _event_data ;
-(void *) addingEventData ;

-(bool)checkEvent:(sd_event_t ) _event_type ;
-(bool)checkClick ;
-(bool)checkDoubleClick ;
-(bool)checkDrag;
-(bool)checkDragAndDrop ;

-(bool)sendEventTo:(SDWindow*)_window ;

@end 


#endif
