#ifndef INTERFACE_SDObject
#define INTERFACE_SDObject  1
#include "objc/objc.h"
#include "objc/objc-api.h"
//#include "objc/runtime.h"

#include "objc/Object.h"

#define NORMAL_INSTANCE  0
#define STACK_INSTANCE   0x8

#define IRREMOVABLE      0x100
#define UNEDITABLE       0x200
#define UNEXTENDABLE     0x400

#define OBJECTDATA       0x1000

typedef  long long            llint ;
typedef unsigned long long    ullint ;
typedef unsigned long         ulong;
typedef unsigned int          uint ;
typedef unsigned short        ushort ;
typedef char                  byte ;
typedef unsigned char         ubyte ;

typedef enum bool_e {false , true } bool;

@interface SDObject : Object
{
 unsigned long mm_type ;
}

+(Class) self ;
+(Class) class ;
+(ulong ) instanceSize ;
+(char * ) name ;
+(bool)isClass;
+(bool)isMetaClass;
+(Class) isExist ;
+free ;

-(id) new ;
-(bool) isFalse  ;
-(bool) isTrue ;
-(bool) isExist ;

-(unsigned long) mmType ;
-(id) mmType: (unsigned long ) _type  ;

-(id) removable ;
-(id) editable ;
-(id) extendable ;

-(id) irremovable ;
-(id) uneditable ;
-(id) unextendable ;
-(id) stackInstance ;

-(bool) isRemovable ;
-(bool) isEditable ;
-(bool) isExtendable ;
-(bool) isStackInstance ;

@end

#define SD_OBJECT_IS_CLASS(object)\
( ((Class)object)->class_pointer->name != ((Class)object)->class_pointer->class_pointer->name )

#define SD_OBJECT_IS_METACLASS(object)\
 ( (SD_OBJECT_IS_CLASS(object))? (CLS_ISMETA((Class)object)): false )

#define SD_OBJECT_IS_INSTANCE(object)\
( ((Class)object)->class_pointer->name == ((Class)object)->class_pointer->class_pointer->name )?true:false 

#define ___STACK_( cls , x  ,line, arg... ) \
struct {@defs(cls)} __temparary_variable_$_ ##cls ##__ ##x ##__ ##line []= {[cls self] , STACK_INSTANCE , ##arg};\
cls * x = __temparary_variable_$_ ##cls ##__ ##x ##__ ##line

#define __STACK_(cls,x,line,arg...) ___STACK_(cls,x,line,arg)
#define STACK(cls,x,arg...)      __STACK_(cls,x,__LINE__,arg)

#endif
