#ifndef INTERFACE_SDUIXBase
#define INTERFACE_SDUIXBase  1

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>

#define MASK_ALL 0xFFFFFFFF

@class SDEvent ;
extern Class SDUIXBase_fast;

@interface SDUIXBase : SDUIBase
{
 @public
 Display * display; 
 XEvent event ;
} 

-(id)display:(Display *) _display ;
-(Display *) display ;

-(Screen *) defaultScreen;

-(void)allowEvents:(int) _event_mode with: (Time) _time ;
-(int)numberOfEvents:(int) _mode ;
-(int)pendingEventsNumber ;
-(int)numberOfEvents ;

-(long)rootEventMask;
-(int)putBackEvent ;
-(int)sendEvent:(Window )_window 
           prop: (bool) _propagate
           mask: (long) _mask ;

-(SDEvent *)readOnlyEventDo:(SEL)_running_method  with:(id)_arg;

-(SDEvent *)waitEventDo:(SEL) _running_method with:(id)_arg ;
-(SDEvent *)waitEventMask:(long) _event_mask ;
-(SDEvent *)waitEventWindow:(Window )_window with:(long)_event_mask; 



-(SDEvent *)nonWaitEventDo: (SEL) _running_method with:(id)_arg;
-(SDEvent *)nonWaitEventMask:(long) _event_mask ;
-(SDEvent *)nonWaitEventType:(int) _event_type ;
-(SDEvent *)nonWaitEventWindow:(Window ) _window;
-(SDEvent *)nonWaitEventWindow:(Window ) _window type:(int) _type  ;

-(bool)checkEvent; 
-(bool)checkEvent:(id) _arg;

-(int)flush ;
@end 
extern int SDEvent_convert_XEvent (SDEvent * _src_event , XEvent * _dest_event);
extern int XEvent_convert_SDEvent (XEvent * _srv_event , SDEvent * _dest_event );

#endif
