#include <SDObject.h>
#include <SDEvent.h>
#include <SDUIBase.h>
#include <SDUIXBase.h>
#include <SDWindow.h>
#include <SDXWindow.h>

Class SDUIXBase_fast;
#define KeyPress         2
#define KeyRelease       3
#define ButtonPress      4
#define ButtonRelease         5
#define MotionNotify          6    
#define EnterNotify      7
#define LeaveNotify      8
#define FocusIn               9
#define FocusOut         10
#define KeymapNotify          11
#define Expose           12
#define GraphicsExpose        13
#define NoExpose         14
#define VisibilityNotify 15
#define CreateNotify          16
#define DestroyNotify         17
#define UnmapNotify      18
#define MapNotify        19
#define MapRequest       20
#define ReparentNotify        21
#define ConfigureNotify       22
#define ConfigureRequest 23
#define GravityNotify         24
#define ResizeRequest         25   
#define CirculateNotify       26
#define CirculateRequest 27
#define PropertyNotify        28
#define SelectionClear        29
#define SelectionRequest 30
#define SelectionNotify       31
#define ColormapNotify        32
#define ClientMessage         33
#define MappingNotify         34
#define LASTEvent        35   /* must be bigger than any event # */

int SDEvent_convert_XEvent (SDEvent * _src_event , XEvent * _dest_event)
{
 
}

int XEvent_convert_SDEvent (XEvent * _src_event , SDEvent * _dest_event )
{
 swith(_src_event->type)
 {
    case: KeyPress  
          { 
           _dest_event->type= sd_key_down ;
           break; 
          }
    
    case: KeyRelease      
          {
           _dest_event->type=sd_key_up ;
           break;
          }  
    case: ButtonPress     
          {
           _dest_event->type=sd_mouse_button_press ;
           break;
          } 
    case: ButtonRelease   
          {
           _dest_event->type=sd_mouse_button_release ;
           break;
          } 
    case: MotionNotify    
          {
           _dest_event->type=sd_system_event ;
           break;
          } 
    case: EnterNotify     
          {
           _dest_event->type=sd_system_event ;
           break;
          } 
    case: LeaveNotify     
          {
           _dest_event->type=sd_system_event ;
           break;
          } 
    case: FocusIn         
          {
           _dest_event->type=sd_system_event ;
           break;
          } 
    case: FocusOut        
          {
           _dest_event->type=sd_system_event ;
           break;
          } 
    case: KeymapNotify    
          {
           _dest_event->type=sd_system_event ;
           break;
          } 
    case: Expose          
          {
           _dest_event->type=sd_system_event ;
           break;
          }
    case: GraphicsExpose  
          {
           _dest_event->type=sd_system_event ;
           break;
          } 
    case: NoExpose        
          {
           _dest_event->type=sd_system_event ;
           break;
          } 
    case: VisibilityNotify
          {
           _dest_event->type=sd_system_event ;
           break;
          } 
    case: CreateNotify    
          {
           _dest_event->type=sd_system_event ;
           break;
          }     
    case: DestroyNotify   
          {
           _dest_event->type=sd_system_event ;
           break;
          } 
    case: UnmapNotify     
          {
           _dest_event->type=sd_system_event ;
           break;
          } 
    case: MapNotify       
          {
           _dest_event->type=sd_system_event ;
           break;
          } 
    case: MapRequest      
          {
           _dest_event->type=sd_system_event ;
           break;
          } 
    case: ReparentNotify  
          {
           _dest_event->type=sd_system_event ;
           break;
          } 
    case: ConfigureNotify 
          {
           _dest_event->type=sd_system_event ;
           break;
          } 
    case: ConfigureRequest
          {
           _dest_event->type=sd_system_event ;
           break;
          } 
    case: GravityNotify   
          {
           _dest_event->type=sd_system_event ;
           break;
          } 
    case: ResizeRequest   
          {
           _dest_event->type=sd_system_event ;
           break;
          }

    case: CirculateNotify 
          {
           _dest_event->type=sd_system_event ;
           break;
          } 
    case: CirculateRequest
          {
           _dest_event->type=sd_system_event ;
           break;
          } 
    case: PropertyNotify  
          {
           _dest_event->type=sd_system_event ;
           break;
          } 
    case: SelectionClear  
          {
           _dest_event->type=sd_system_event ;
           break;
          } 
    case: SelectionRequest
          {
           _dest_event->type=sd_system_event ;
           break;
          } 
    case: SelectionNotify 
          {
           _dest_event->type=sd_system_event ;
           break;
          } 
    case: ColormapNotify  
          {
           _dest_event->type=sd_system_event ;
           break;
          } 
    case: ClientMessage   
          {
           _dest_event->type=sd_system_event ;
           break;
          } 
    case: MappingNotify   
          {
           _dest_event->type=sd_system_event ;
           break;
          } 
    case: LASTEvent       
          {
           break;
          } 
 }    
}
@implementation SDUIXBase 
/*

{
 @public
 Display * display; 
 XEvent event ;
} 
*/

-(id)display:(Display *) _display ;
{
 display = _display ;
 return self ;
} 

-(Display *) display ;
{
 return display ;
} 

-(Screen*) defaultScreen
{
 return DefaultScreenOfDisplay(display);
}

-(void)allowEvents:(int) _event_mode with: (Time) _time ;
{
 XAllowEvent ( display ,_event_mode , _time );
} 

-(int)numberOfEvents:(int) _mode ;
{
 return  XEventQueued(display,_mode );
}

-(int)pendingEventsNumber ;
{
 return XPending(display);
}

-(int)numberOfEvents ;
{
 return XQLength(display);
}

-(long)rootEventMask;
{
 return XEventMaskOfScreen(DefaultScreenOfDisplay(display));
} 


-(int)putBackEvent ;
{
 return XPutBackEvent(display,&event);
} 

-(int)sendEvent:(Window )_window 
           prop: (bool) _propagate
           mask: (long) _mask ;
{
 return XSendEvent(display , _window , _propagate,_mask, &event);
} 

-(SDEvent *)readOnlyEventDo:(SEL)_running_method with:(id)_arg ;
{
 SDUIXBase *check_object=self ;
 SEL run_sel=_running_method;

 Bool nest_func(Display *d ,XEvent e,XPointer *args )
 {
  return (bool)[check_object perform:run_sel with: (id)args  ];
 } 

 XPeekIfEvent(display ,&event , nest_func ,(XPointer)_arg);

 sd_event->adding_event_data = &event ;

 return sd_event ;
} 


-(SDEvent *)waitEventDo: (SEL) _running_method  with:(id)_arg ;
{
 SDUIXBase * check_object=self ;
 SEL run_sel =  _running_method;
 
Bool nest_check_func(Display *d ,XEvent e,XPointer *args )
{
 return (bool)[check_object perform:run_sel with:(id)args ];
}

 XIfEvent(display ,&event , nest_check_func ,(XPointer)_arg);


 sd_event->adding_event_data = &event ;

 return sd_event ;
} 
 
-(SDEvent *)waitEventMask:(long) _event_mask ;
{
 XMaskEvent(display ,_event_mask , &event );
 
 sd_event->adding_event_data = &event ;
 return sd_event ;
}
 
-(SDEvent *)waitEventWindow:(Window )_window with:(long)_event_mask ; 
{
 XWindowEvent(display ,_window, _event_mask , &event );
 
 sd_event->adding_event_data = &event ;
 return sd_event ;
}

-(SDEvent *)nonWaitEventDo:(SEL) _running_method with:(id)_arg ;
{
 SDUIXBase * check_object=self ;
 SEL run_sel =  _running_method;
 
Bool nest_check_func(Display *d ,XEvent e,XPointer *args )
{
 return (bool)[check_object perform:run_sel with:(id)args ];
}

 XPeekIfEvent(display ,&event , nest_check_func ,(XPointer)_arg);


 sd_event->adding_event_data = &event ;

 return sd_event ;

}


-(SDEvent *)nonWaitEventMask:(long) _event_mask ;
{
 XCheckMaskEvent(display ,_event_mask , &event );
 
 sd_event->adding_event_data = &event ;
 return sd_event ;
}

-(SDEvent *)nonWaitEventType:(int) _event_type ;
{
 XCheckTypedEvent(display ,_event_type , &event );
 
 sd_event->adding_event_data = &event ;
 return sd_event ;
}

-(SDEvent *)nonWaitEventWindow:(Window ) _window;
{
 XCheckTypedEvent(display ,_window , &event );
 
 sd_event->adding_event_data = &event ;
 return sd_event ;
}

-(SDEvent *)nonWaitEventWindow:(Window ) _window type:(int) _type  ;
{
 XCheckTypedWindowEvent(display ,_window , _type , &event );
 
 sd_event->adding_event_data = &event ;
 return sd_event ;
}

-(bool)checkEvent;
{
 return false ;
}

-(bool)checkEvent:(id)_arg ;
{
 return false ;
}

/* implementation  SDUIBase */

 
-(int)screenNumber ;
{
 return ScreenCount(display) ;
}

-(int)currentScreenNumber ;
{
 return DefaultScreen(display);
}

-(SDEvent *)readOnlyEvent ;
{
 
 SDEvent  * return_event ; 
 XPeekEvent(display , &event );

 sd_event->adding_event_data = &event ;
 return sd_event ;
}

-(SDEvent *)waitEvent ;
{
 XNextEvent(display , &event );

 sd_event->adding_event_data = &event ;
 return sd_event ;
}

-(SDEvent *)waitEventSDWindow:(SDWindow *)_window ;
{
 XWindowEvent(display ,((SDXWindow *)_window)->  window,  MASK_ALL , &event );
 sd_event->adding_event_data = &event ;
 return sd_event;
}

-(bool)nonWaitEvent: (inout SDEvent *) _event ;
{
  return XCheckMaskEvent( display, MASK_ALL , _event ); 
}

-(SDEvent *)nonWaitEventSDWindow:(SDWindow* ) _window;
{
 if( XCheckWindowEvent(display , ((SDXWindow *)_window)-> window,MASK_ALL , &event))
 {
  sd_event -> adding_event_data = &event  ;
  return sd_event ;
 }
 else 
 {
  return nil ;
 } 
}

-(int)flush ;
{
  return XFlush(display);
}  

@end 

